//---------------------------------------------------------------------------

#pragma hdrstop
#include "defs.hpp"
#include "Scanner.h"
#include "Diagram.h"
#include "Semantic.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
TScanner* Scan;
Tree* Sem;

void S()  //
{
  LexWord l; int t; Lex* uk;
  uk = Scan->CL;
  while ((t = Scan->ReturnCur()) != TEnd)
    {
      if (t == DefVoid)
        {
          Scan->CL = uk;
          F();
        }
      else
      if (t == DefEnum)
        {
          Scan->CL = uk;
          E();
          t = Scan->ReturnCur();
          if (t != TypeDivider) Scan->ShowError(" ; ,   " , AnsiString(Scan->CL->prev->l),1);
        }
      else
      if (t == DefConst)
        {
          T();
          t = Scan->ReturnCur();
          if (t != TypeDivider) Scan->ShowError(" ; ,   " , AnsiString(Scan->CL->prev->l),1);
        }
      else
      if (t == DefInt)
        {
          t = Scan->ReturnCur(); Scan->CL = uk; //  2!
          if (t == DefMain) F();
          else
          if (t == TypeIdent)
            {
              L();
              t = Scan->ReturnCur();
              if (t != TypeDivider) Scan->ShowError(" ; ,   " , AnsiString(Scan->CL->prev->l),1);
            }
          else Scan->ShowError("   main,   " , AnsiString(Scan->CL->prev->l),1);
        }
      else Scan->ShowError("  ,   " , AnsiString(Scan->CL->prev->l),1);
      uk = Scan->CL;
    }
}

void L()
{
  LexWord l; int t; Lex* uk; int arsize;
  Tree* v; //- ,       
  t = Scan->ReturnCur();
  if ((t != DefInt) && (t != DefFloat)) Scan->ShowError(" int,   " , AnsiString(Scan->CL->prev->l),1);
  DATA_TYPE vartype = RetType(t);
  do
    {
      t = Scan->ReturnCur();
      if (t != TypeIdent) Scan->ShowError(" ,   " , AnsiString(Scan->CL->prev->l),1);
      v = Sem->SemInclude(Scan->CL->prev->l, vartype);
      uk = Scan->CL; t = Scan->ReturnCur();
      if (t == TypeEq)
        {
          V();                 //  ???
          uk = Scan->CL; t = Scan->ReturnCur(); //   ,   -   ,
        }
      else
      if (t == TypeLeftA)
        {
          Scan->CL = uk;
          R(&arsize);
          Sem->SemSetArray(v, true);
          Sem->SemSetParam(v, arsize);
          uk = Scan->CL; t = Scan->ReturnCur(); //   ,   -   ,
        }
    }
  while (t == TypeComma);
  Scan->CL = uk;  //.    ;
}

void T()
{
  LexWord l; int t; Lex* uk;
  Tree* v;
  t = Scan->ReturnCur();
  if (!((t == DefInt) || (t == DefFloat))) Scan->ShowError("  ,   " , AnsiString(Scan->CL->prev->l),1);
  int vartype = RetType(t);
  do
    {
      t = Scan->ReturnCur();
      if (t != TypeIdent) Scan->ShowError(" ,   " , AnsiString(Scan->CL->prev->l),1);
      v = Sem->SemInclude(Scan->CL->prev->l, vartype); //  
      uk = Scan->CL; t = Scan->ReturnCur();
      if (t == TypeEq)
        {
          V();
          uk = Scan->CL; t = Scan->ReturnCur();
          Sem->SemSetConst(v,true);  //     ()
        }
      else Scan->ShowError(" =,   " , AnsiString(Scan->CL->prev->l),1);
    }
  while (t == TypeComma);
  Scan->CL = uk; // 
}

void F()  ///
{
  LexWord l; int t; Lex* uk;
  Tree *funct, *v;  //    
  DATA_TYPE vartype;
  v = Sem->Cur;
  t = Scan->ReturnCur();
  if ((t != DefInt) && (t != DefVoid)) Scan->ShowError(" int, void  float,   " , AnsiString(Scan->CL->prev->l),1);
  if (t == DefInt) vartype = TYPE_INTEGER;
  else if (t == DefFloat) vartype = TYPE_FLOAT;
       else vartype = TYPE_VOID;
  t = Scan->ReturnCur();
  if (t != DefMain) Scan->ShowError(" main,   " , AnsiString(Scan->CL->prev->l),1);
  funct = Sem->SemInclude(Scan->CL->prev->l, TYPE_FUNCT);
  t = Scan->ReturnCur();
  if (t != TypeOpen) Scan->ShowError(" (,   " , AnsiString(Scan->CL->prev->l),1);
  t = Scan->ReturnCur();
  if (t != TypeClose)  //  
    {
      uk = Scan->CL; t = Scan->ReturnCur(); Scan->CL = uk;
      if (t == DefInt)
        {
          P();
          t = Scan->ReturnCur();
          if (t != TypeClose) Scan->ShowError(" ),   " , AnsiString(Scan->CL->prev->l),1);
        }
      else Scan->ShowError("   ),   " , AnsiString(Scan->CL->prev->l),1);
    }
  uk = Scan->CL; t = Scan->ReturnCur(); Scan->CL = uk;
  if (t != TypeBeg) Scan->ShowError(" {,   " , AnsiString(Scan->CL->prev->l),1);
  TE();
  Sem->Cur = v;
}

void E()  //enum
{
  LexWord l; int t; Lex* uk;
  Tree *v;
  t = Scan->ReturnCur();
  if (t != DefEnum) Scan->ShowError(" enum,   " , AnsiString(Scan->CL->prev->l),1); //???
  t = Scan->ReturnCur();
  if (t != TypeBeg) Scan->ShowError(" {,   " , AnsiString(Scan->CL->prev->l),1);
  uk = Scan->CL; t = Scan->ReturnCur();
  if (t != TypeEnd)
    {
      if (t != TypeIdent) Scan->ShowError("   },   " , AnsiString(Scan->CL->prev->l),1);
      Scan->CL = uk;
      PR();
      t = Scan->ReturnCur();
      if (t != TypeEnd) Scan->ShowError(" },   " , AnsiString(Scan->CL->prev->l),1);
    }
  do
    {
      t = Scan->ReturnCur();
      if (t != TypeIdent) Scan->ShowError(" ,   " , AnsiString(Scan->CL->prev->l),1);
      v = Sem->SemInclude(Scan->CL->prev->l, TYPE_ENUM);
      uk = Scan->CL; t = Scan->ReturnCur();
    }
  while (t == TypeComma);
  Scan->CL = uk;
}

void P()
{
  LexWord l; int t; Lex* uk;
  Tree *v;
  do
    {
      t = Scan->ReturnCur();
      if ((t != DefInt) && (t != DefFloat)) Scan->ShowError(" int  float,   " , AnsiString(Scan->CL->prev->l),1);
      DATA_TYPE vartype = RetType(t);
      t = Scan->ReturnCur();
      if (t != TypeIdent) Scan->ShowError(" ,   " , AnsiString(Scan->CL->prev->l),1);
      v = Sem->SemInclude(Scan->CL->prev->l, vartype); //  
      uk = Scan->CL; t = Scan->ReturnCur();
    }
  while (t == TypeComma);
  Scan->CL = uk;
}

void TE()  // .  ?     ...
{
  LexWord l; int t; Lex* uk;
  t = Scan->ReturnCur();
  if ( t != TypeBeg) Scan->ShowError(" {,   " , AnsiString(Scan->CL->prev->l),1);
  PO();  //  
  t = Scan->ReturnCur();
  if ( t != TypeEnd) Scan->ShowError(" },   " , AnsiString(Scan->CL->prev->l),1);
}

void OP()
{
  LexWord l; int t; Lex* uk;
  uk = Scan->CL; t = Scan->ReturnCur();
  switch (t)
    {
      case TypeIdent:Scan->CL = uk;
                     EQ(); break;
      case DefSwitch:Scan->CL = uk;
                     SW(); break;
      case TypeDivider:Scan->CL = uk;break; //,    ; 
      case DefRet:Scan->CL = uk;
                  RT(); break;
      case DefFloat:
      case DefInt:Scan->CL = uk;
                  L(); break;
      case DefConst:T(); break;
      case DefEnum:Scan->CL = uk;
                   E();break;
      case TypeBeg:Scan->CL = uk;
                   TE();break;
      default:Scan->ShowError(" ,  switch, ;, return, int, const  enum,   " , AnsiString(Scan->CL->prev->l),1);
    }
  int tprev = t;           //    ?
  uk = Scan->CL; t = Scan->ReturnCur();
  if ((t != TypeDivider) && (tprev != TypeBeg)) Scan->ShowError(" ;,   " , AnsiString(Scan->CL->prev->l),1);
  else
  if (tprev == TypeBeg) Scan->CL = uk;//,    
}//   ;  .

void PR()
{
  LexWord l; int t; Lex* uk;
  Tree* v;
  do
    {
      t = Scan->ReturnCur();
      if (t != TypeIdent) Scan->ShowError(" ,   " , AnsiString(Scan->CL->prev->l),1);
      v = Sem->SemInclude(Scan->CL->prev->l, TYPE_INTEGER); //  
      Sem->SemSetConst(v, true); // enum'a -  
      uk = Scan->CL;t = Scan->ReturnCur();
      if (t == TypeEq)  // -
        {
          t = Scan->ReturnCur();
          if (t != TypeInt) Scan->ShowError("  ,   " , AnsiString(Scan->CL->prev->l),1);
          uk = Scan->CL; t = Scan->ReturnCur(); //     ,
        }
    }
  while (t == TypeComma);
  Scan->CL = uk;
}

DATA_TYPE EQ()  //  ,   "" 
{
  LexWord l; int t; Lex* uk; DATA_TYPE restype;
  Tree* v;
                   //  1     =
  t = Scan->ReturnCur();
  if (t != TypeIdent) Scan->ShowError(" ,   " , AnsiString(Scan->CL->prev->l),1);
  v = Sem->FindUp(Scan->CL->prev->l);
  if (!v) Scan->ShowError("   " , AnsiString(Scan->CL->prev->l),1);
  t = Scan->ReturnCur();
  if (t != TypeEq) Scan->ShowError(" =,   " , AnsiString(Scan->CL->prev->l),1);
  uk = Scan->CL; Scan->ReturnCur(); t = Scan->ReturnCur(); // ,    =
  Scan->CL = uk;
  if (t == TypeEq) restype = EQ();
  else restype = V();
  return restype;
}

void R(int *c)
{
  LexWord l; int t; Lex* uk; DATA_TYPE restype; int razm = 0;
  do                  // ?
    {
      t = Scan->ReturnCur();
//      if (t != TypeLeftA) Scan->ShowError(" [,   " , AnsiString(Scan->CL->prev->l),1);  //  , ..     [
      int restype = V();
      if ((restype != TYPE_INTEGER) && (restype != TYPE_UNKNOWN)) Scan->ShowError("    !" , AnsiString(Scan->CL->prev->l),1);
      t = Scan->ReturnCur();
      if (t != TypeRightA) Scan->ShowError(" ],   " , AnsiString(Scan->CL->prev->l),1);
      razm++;
      uk = Scan->CL; t = Scan->ReturnCur(); Scan->CL = uk;
    }
  while (t == TypeLeftA);
  *c = razm;
}

DATA_TYPE V() //
{
  LexWord l; int t; Lex* uk;
  DATA_TYPE restype = OPR();
  uk = Scan->CL; t = Scan->ReturnCur(); //   ,     
   while ((t == TypeGt) || (t == TypeLt) || (t == TypeGe) || (t == TypeLe) || (t == TypeNe))
    {
      restype = Sem->OperControl(restype, OPR(), t);
      uk = Scan->CL; t = Scan->ReturnCur();
    }
  Scan->CL = uk;
  return restype;
}

DATA_TYPE OPR() // (/)
{
  LexWord l; int t; Lex* uk;
  DATA_TYPE restype = SM();
  uk = Scan->CL; t = Scan->ReturnCur();
  while ((t == TypePlus) || (t == TypeMinus))
    {
      restype = Sem->OperControl(restype, SM(), t);
      uk = Scan->CL; t = Scan->ReturnCur();
    }
  Scan->CL = uk;
  return restype;
}

DATA_TYPE SM() ///
{
  LexWord l; int t; Lex* uk;
  DATA_TYPE restype = M();
  uk = Scan->CL; t = Scan->ReturnCur();
  while ((t == TypeMult) || (t == TypeDiv) || (t == TypeRest))
    {
      restype = Sem->OperControl(restype, M(), t);
      uk = Scan->CL; t = Scan->ReturnCur();
    }
  Scan->CL = uk;
  return restype;
}

DATA_TYPE M() // 
{
  LexWord l; int t; Lex* uk; DATA_TYPE restype;
  uk = Scan->CL; t = Scan->ReturnCur();
  if ((t == TypeMinus) || (t == TypeInc) || (t == TypeDec)) return Sem->OperControl(OND(), t);
  else
    {
      Scan->CL = uk;
      restype = OND();
      uk = Scan->CL; t = Scan->ReturnCur();
      if ((t != TypeInc) && (t != TypeDec)) Scan->CL = uk; // 
    }
  return Sem->OperControl(restype, t);
}

DATA_TYPE OND()  // -  ,    ,  - ,    ""
{
  LexWord l; int t; Lex* uk;  int arsize;
  Tree* v;
  DATA_TYPE restype;
  t = Scan->ReturnCur();
  if (t == TypeNot) t = Scan->ReturnCur(); // "!" -   
  if ((t != TypeIdent) && (t != TypeInt) && (t != TypeFloat) && (t != TypeOpen)) Scan->ShowError("   ,   " , AnsiString(Scan->CL->prev->l),1);
  if (t == TypeIdent) //  -  
    {
      v = Sem->FindUp(Scan->CL->prev->l);
      if (!v) Scan->ShowError("   " , AnsiString(Scan->CL->prev->l),1);
      uk = Scan->CL; t = Scan->ReturnCur(); Scan->CL = uk;
      if (t == TypeLeftA)
        {
          R(&arsize);
          Sem->ArrControl(v,arsize);  // 
        }
      return v->n->DataType; //  -  
    }
  else
  if (t == TypeOpen) //  
    {
      restype = V();
      t = Scan->ReturnCur();
      if (t != TypeClose) Scan->ShowError(" ),   " , AnsiString(Scan->CL->prev->l),1);
      return restype;
    }
  else
  if (t == TypeInt) return TYPE_INTEGER;
  else
  if (t == TypeFloat) return TYPE_FLOAT;
}

void RT()
{
  LexWord l; int t; Lex* uk;
  t = Scan->ReturnCur(); //   ,  return  
  V();
}

void PO()  //  
{
  LexWord l; int t; Lex* uk;
  uk = Scan->CL; t = Scan->ReturnCur();
  while ((t == TypeIdent) ||
         (t == DefSwitch) ||
         (t == TypeDivider) ||
         (t == DefRet) ||
         (t == DefInt) ||
         (t == DefFloat) ||
         (t == DefConst) ||
         (t == TypeBeg) ||
         (t == DefEnum)       )
    {
      switch (t) {
        case TypeIdent:
        case DefSwitch:
        case TypeDivider:
        case TypeBeg:
        case DefRet:
        case DefInt:
        case DefFloat:
        case DefConst:
        case DefEnum:Scan->CL = uk;
                     OP();break;
                }
      uk = Scan->CL; t = Scan->ReturnCur();
    }
  Scan->CL = uk;
}

void SW()
{
  LexWord l; int t; Lex* uk;
  t = Scan->ReturnCur(); //   - switch  
  t = Scan->ReturnCur();
  if (t != TypeOpen) Scan->ShowError(" (,   " , AnsiString(Scan->CL->prev->l),1);
  if (V() == TYPE_FLOAT) Scan->ShowError(" SWITCH    ,   " , AnsiString(Scan->CL->prev->l),1);
  t = Scan->ReturnCur();
  if (t != TypeClose) Scan->ShowError(" ),   " , AnsiString(Scan->CL->prev->l),1);
  t = Scan->ReturnCur();
  if (t != TypeBeg) Scan->ShowError(" {,   " , AnsiString(Scan->CL->prev->l),1);
  SLS();
  uk = Scan->CL; t = Scan->ReturnCur();
  if (t != TypeEnd)       //  default
    {
      if (t == DefDefault)
        {
          Scan->CL = uk;
          SLD();   //  ?  ,   
          t = Scan->ReturnCur();
          if (t != TypeEnd) Scan->ShowError(" },   " , AnsiString(Scan->CL->prev->l),1);
        }
      else Scan->ShowError(" }  default,   " , AnsiString(Scan->CL->prev->l),1);
    }
}

void SLS()
{
  LexWord l; int t; Lex* uk;
  uk = Scan->CL; t = Scan->ReturnCur(); Scan->CL = uk;
  if ((t != DefCase) && (t != DefDefault) && (t != TypeEnd)) Scan->ShowError(" case, default  },   " , AnsiString(Scan->CL->prev->l),1);
  while (t == DefCase)
    {
      SL();
      uk = Scan->CL; t = Scan->ReturnCur(); Scan->CL = uk;
    }
}

void SL()  // switch'
{
  LexWord l; int t; Lex* uk;
  t = Scan->ReturnCur();  // , case  
  t = Scan->ReturnCur();
  if (t != TypeInt) Scan->ShowError("  ,   " , AnsiString(Scan->CL->prev->l),1);
  t = Scan->ReturnCur();
  if (t != TypePoint2) Scan->ShowError(" :,   " , AnsiString(Scan->CL->prev->l),1);
  PO();
  uk = Scan->CL; t = Scan->ReturnCur();
  if (t == DefBreak)
    {
      t = Scan->ReturnCur();
      if (t != TypeDivider) Scan->ShowError(" ;,   " , AnsiString(Scan->CL->prev->l),1);
    }
  else Scan->CL = uk; //, break'a  ...
}

void SLD() //default.    
{
  LexWord l; int t; Lex* uk;
  t = Scan->ReturnCur();  // , default  
  t = Scan->ReturnCur();
  if (t != TypePoint2) Scan->ShowError(" :,   " , AnsiString(Scan->CL->prev->l),1);
  PO();
  uk = Scan->CL; t = Scan->ReturnCur();
  if (t == DefBreak)
    {
      t = Scan->ReturnCur();
      if (t != TypeDivider) Scan->ShowError(" ;,   " , AnsiString(Scan->CL->prev->l),1);
    }
  else Scan->CL = uk; //, break'a  ...
}


//------------------------------------------------------
void Init(TScanner* NewScanner, Tree* InitialTree)
{
  if (!NewScanner) NewScanner = new TScanner();
  Scan = NewScanner;
  if (!InitialTree) InitialTree = new Tree();
  Sem = InitialTree;
}

void Remove()
{
  delete Scan;
  delete Sem;
}

DATA_TYPE RetType(int DefType)      // int,  float
{
  if (DefType == DefInt) return TYPE_INTEGER;
  else return TYPE_FLOAT;
}
