//---------------------------------------------------------------------------


#pragma hdrstop
#include "String.h"
#include "Scanner.h"
#include <io.h>
#include <SysUtils.hpp>
#include <Dialogs.hpp>

//---------------------------------------------------------------------------

#pragma package(smart_init)

int uk;  //
char* t;   //
TypeLex Keyword;

TScanner::TScanner(/*TStrings* NewLogList*/)  //   
{
  Keyword[0].code = 1;
  Keyword[0].LexWord = "int";
  Keyword[1].code = 2;
  Keyword[1].LexWord = "enum";
  Keyword[2].code = 3;
  Keyword[2].LexWord = "float";
  Keyword[3].code = 4;
  Keyword[3].LexWord = "const";
  Keyword[4].code = 5;
  Keyword[4].LexWord = "main";
  Keyword[5].code = 6;
  Keyword[5].LexWord = "return";
  Keyword[6].code = 7;
  Keyword[6].LexWord = "switch";
  Keyword[7].code = 8;
  Keyword[7].LexWord = "case";
  Keyword[8].code = 9;
  Keyword[8].LexWord = "default";
  Keyword[9].code = 10;
  Keyword[9].LexWord = "break";
  Keyword[10].code = 11;
  Keyword[10].LexWord = "void";
}

int TScanner::GetData(const AnsiString FileName)
{
  int res = FileOpen(FileName,fmOpenRead);
  if (res < 0)
    {
      ShowError("   !",FileName,1);
      return -1;//
    }
  else
    {
      int ln = FileSeek(res,0,2);
      t = new char[ln];
      if (ln < MAX_TEXT - 1)
        {
          FileSeek(res,0,0);  //  
          FileRead(res,t,ln);
          t[ln] = '\0';
          FileClose(res);
          TextLen = ln;
          return ln;
        }
      else
        {
          ShowError("    - ",FileName+ " !",1);
          FileClose(res);
          return -2;//  
        }
    }
}

void TScanner::PutUK(int i) {uk = i;} // 

int TScanner::GetUK() { return uk; } // 

void TScanner::LogError(const AnsiString err, const AnsiString a, bool WantTerminate)
//   
{
  if (a=="")
     {
//       LogList->Add(" : " + err + a);
     }
    else
//    LogList->Add(" : " + err + ".  " + a);
  if (WantTerminate)
    {
//      LogList->SaveToFile("listing.lst");
      exit(0);
    }
}

void TScanner::ShowError(const AnsiString err, const AnsiString wrong, bool WantTerminate)
//   
{
  if (wrong.Length() > 0) ShowMessage(err + wrong + "\n : (" + IntToStr(CL->prev->line + 1) + ":" + IntToStr(CL->prev->beg) + ")");
  else ShowMessage(err + " .");
  if (WantTerminate)
    {
      exit(0);
    }
}

void TScanner::Pass() //  
{
  while ((t[uk] == ' ') || (t[uk] == '\n') || (t[uk] == '\r') || (t[uk] == '\t') || (t[uk]=='/') && ((t[uk+1]=='/') || (t[uk+1]=='*')))
    {
      if (t[uk]=='/')
        if (t[uk+1]=='/') //        /
            {
              while (t[uk]!='\n')
                {
                  uk++;
                  if (uk ==TextLen) return;
                }
              uk--; //      
            }
//-------------------------------------------
        else if (t[uk+1] == '*')
            {
              uk=uk+2;
              while (!((t[uk]=='/') && (t[uk-1]=='*')))
                {
                  if ( t[uk] == '\n' )
                    {
                      CurLine++;
                      CurPos = 0;
                    }
                  uk++;
                  CurPos++;
                  if (uk == TextLen) return;
                }
            }
      if (t[uk] == '\n')
        {
          CurLine++;
          CurPos = 0;
        }
      uk++;
      CurPos++;
    }
//  uk--; //  1  //  
}

int TScanner::Scaner(LexWord l)
{
  int i; //.  
  for (i=0; i < MAX_LEX; i++) l[i]=0;  //  
  i=0; //  
  Pass();
  if (uk == TextLen) {l[0]='\0'; return TEnd;}
  beg = CurPos; // .
  if ((t[uk]<='9') && (t[uk]>='0'))
    {
      l[i++] = t[uk++];
      while ((t[uk]<='9') && (t[uk]>='0'))
        {
           if (i < MAX_LEX-1) l[i++] = t[uk++];
           else uk++;
        }
      if (t[uk] == '.') {l[i++] = t[uk++]; goto N1;}
      //AddLex(TypeInt,l,beg);
      return TypeInt;
    }
  else if ((t[uk]>='a') && (t[uk]<='z') || (t[uk]>='A') && (t[uk]<='Z'))
         {  // 
            l[i++] = t[uk++];
            while (  (t[uk]<='9') && (t[uk]>='0') ||
                     (t[uk]>='a') && (t[uk]<='z') ||
                     (t[uk]>='A') && (t[uk]<='Z')   )
                      {
                        if (i < MAX_LEX-1) l[i++]=t[uk++];
                        else uk++; //  - !
                      }
                      int j;//  . 
                      for (j=0; j<MAX_KEYW; j++)
                        if (strcmp(l,Keyword[j].LexWord)==0)
                          {
                            CurPos = CurPos + i;
                            return Keyword[j].code;  //  - . 
                          }
                      CurPos = CurPos + i;
                      return TypeIdent;
         }
//--------------------------------------------------
  else if (t[uk]=='+')//+  ++
         {
            l[i++]=t[uk++];
            if (t[uk]=='+'){ l[i++]=t[uk++];/*AddLex(TypeInc,l,beg);*/return TypeInc;}
            CurPos = CurPos + i;
            return TypePlus;
         }
  else if (t[uk]=='-')//-  --
         {
            l[i++]=t[uk++];
            if (t[uk]=='-'){ l[i++]=t[uk++]; /*AddLex(TypeDec,l,beg);*/ return TypeDec;}
            CurPos = CurPos + i;
            return TypeMinus;
         }
  else if (t[uk]=='*') // 
         {
            l[i++]=t[uk++];
            CurPos = CurPos + i;
            return TypeMult;
         }
  else if (t[uk]=='/')
         {
            l[i++]=t[uk++];
            CurPos = CurPos + i;
            return TypeDiv;
         }
  else if (t[uk]=='%')
         {
            l[i++]=t[uk++];
            CurPos = CurPos + i;
            return TypeRest;
         }
//--------------------------------------------------------
  else if (t[uk]=='<') //  
         {
            l[i++]=t[uk++];
            if (t[uk]=='='){ l[i++]=t[uk++]; CurPos = CurPos + i;return TypeLe;}
            CurPos = CurPos + i;
            return TypeLt;
         }
  else if (t[uk]=='>')
         {
            l[i++]=t[uk++];
            if (t[uk]=='='){ l[i++]=t[uk++];CurPos = CurPos + i;return TypeGe;}
            CurPos = CurPos + i;
            return TypeGt;
         }
  else if (t[uk]=='=')
         {
            l[i++]=t[uk++];
            if (t[uk]=='='){ l[i++]=t[uk++]; CurPos = CurPos + i; return TypeEe;}
            CurPos = CurPos + i;
            return TypeEq;
         }
  else if (t[uk]=='!')
         {
           l[i++]=t[uk++];
           if (t[uk]=='=') {l[i++]=t[uk++]; CurPos = CurPos + i; return TypeNe;}
           else {
                 // LogError(" ", l);  //
                  CurPos = CurPos + i;
                  return TypeNot;
                }
         }
//---------------------------------------------------------------
  else if (t[uk]==':')
         {
            l[i++]=t[uk++];
            CurPos = CurPos + i;
            return TypePoint2;
         }
  else if (t[uk]==';')
         {
            l[i++]=t[uk++];
            CurPos = CurPos + i;
            return TypeDivider;
         }
  else if (t[uk]=='}')
         {
            l[i++]=t[uk++];
            CurPos = CurPos + i;
            return TypeEnd;
         }
  else if (t[uk]=='{')
         {
            l[i++]=t[uk++];
            CurPos = CurPos + i;
            return TypeBeg;
         }
  else if (t[uk]==')')
         {
            l[i++]=t[uk++];
            CurPos = CurPos + i;
            return TypeClose;
         }
  else if (t[uk]=='(')
         {
            l[i++]=t[uk++];
            CurPos = CurPos + i;
            return TypeOpen;
         }
  else if (t[uk]==',')
         {
            l[i++]=t[uk++];
            CurPos = CurPos + i;
            return TypeComma;
         }
  else if (t[uk]=='[')
         {
            l[i++]=t[uk++];
            CurPos = CurPos + i;
            return TypeLeftA;
         }
  else if (t[uk]==']')
         {
            l[i++]=t[uk++];
            CurPos = CurPos + i;
            return TypeRightA;
         }

  else
       {
           l[i++] = t[uk++];
           ShowError("  ", l,1);  //
           CurPos = CurPos + i;
           return TypeError;
       }
N1: while ((t[uk]<='9') && (t[uk]>='0')) //    
     {
        if (i < MAX_LEX-1) l[i++] = t[uk++];
        else uk++;
     }
    CurPos = CurPos + i;
    return TypeFloat;
    // Scaner
}

void TScanner::AddLex(int Lexcode, LexWord l, int beg, int line)
{
  if (Head)
    {
      if (!Cur)  //   .  - ,   ...
        {
          Cur = Head;
          while (Cur->next) Cur = Cur->next; //...  
        }
      Lex* TMP = new Lex();
      Cur->next = TMP;
      TMP->beg = beg;
      TMP->prev = Cur;
      TMP->type = Lexcode;
      TMP->line = line;
      strcpy(TMP->l,l);
      TMP->next = NULL;
      Cur = TMP;
    }
  else //,   ,    .
    {
      Head = new Lex();
      Head->next = NULL;
      Head->prev = NULL;
      Head->beg = beg;
      Head->type = Lexcode;
      strcpy(Head->l,l);
      Head->line = line;
      Cur = Head;
    }
}
//------------------------------------------------------------------------------
void* TScanner::GetLex(int index)
{
  Lex* TMP = Head;
  for (int i=0; i<index; i++)
    {
       TMP = TMP->next;
    }
  return TMP;
}

int TScanner::ReturnCur()
{
  Lex* TMP = Cur;
  Cur = Cur->next;
  return TMP->type;
}

void TScanner::ScanText()
{
  LexWord l; int type;
  while ((type = Scaner(l)) != TEnd)
    {
       AddLex(type,l,beg,CurLine);
    }
  AddLex(type,l,beg,CurLine); // end
}

void TScanner::ClearLexList()
{
  Cur = Head;
  Lex* TMP;
  while (Cur)
    {
      TMP = Cur;
      Cur = Cur->next;
      delete TMP;
    }
}

TScanner::~TScanner()
{
  ClearLexList();
}


