//---------------------------------------------------------------------------


#pragma hdrstop

#include <string.h>
#include "defs.hpp"
#include "Semantic.h"
#include "Scanner.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)
////---------------------------------------------------------------------------------------
Tree * StartNode = new Tree();
////----------------------------------------------------------------------------------------
void Tree::SetCur(Tree *a)
//   
{
  StartNode->Cur = a;
}
////----------------------------------------------------------------------------------------
Tree* Tree::GetCur(void) //  
{
  return StartNode->Cur;
}
////----------------------------------------------------------------------------------------
Tree* Tree::SemInclude(LexWord a, DATA_TYPE t) //  a     t
{
  Tree *v; Node *b, b1;
  b = new Node;
  memcpy(b->id, a, strlen(a)+1);  b->DataType = t;  b->Data=NULL;
  b->Param = 0;    //
  if (!StartNode->Cur) //   
    StartNode->Cur = new Tree(NULL, NULL, NULL, b);
  else
    {
      StartNode->Cur->SetLeft(b);
      StartNode->Cur = StartNode->Cur->Left;
    }
  if (t ==  TYPE_FUNCT)
    {
      b = new Node();
      v = StartNode->Cur;      //      
      memcpy(b->id, &"", 2);  b->DataType = EMPTY;  b->Data = NULL;
      b->Param = 0; //    0!
      StartNode->Cur->SetRight(b);
      StartNode->Cur = StartNode->Cur->Right;
      return v;
    }
  else return StartNode->Cur;
}
////----------------------------------------------------------------------------------------
void Tree::SemSetType(Tree* Addr, DATA_TYPE t)
//  t     Addr
{
  Addr->n->DataType = t;
}
////----------------------------------------------------------------------------------------
void Tree::SemSetParam(Tree* Addr, int num) //.    
{
  Addr->n->Param = num;
}
////----------------------------------------------------------------------------------------
void Tree::SemControlParam(Tree* Addr, int num) //    
{
  if (num != Addr->n->Param)
    Scan->ShowError("       ", AnsiString(Addr->n->id), 1);
}
////----------------------------------------------------------------------------------------
Tree* Tree::SemGetType(LexWord a)
{
  Tree* v = FindUp(StartNode->Cur, a);
  if (v == NULL)
    Scan->ShowError("   ", AnsiString(a), 1);
  return v;
}
////----------------------------------------------------------------------------------------
int Tree::DupControl(Tree *Addr, LexWord a)
{
 if (FindUpOneLevel(Addr, a) == NULL) return 0;
 return 1;
}
////----------------------------------------------------------------------------------------
DATA_TYPE Tree::OperControl(DATA_TYPE Op1, DATA_TYPE Op2, int OperType)  //     - OperType    Op1  Op2
{
  if ((OperType >= OperLt) && (OperType <= OperNe))
    {
      if ((Op1 == TYPE_EMPTY) || (Op2 == TYPE_EMPTY)) return TYPE_EMPTY;
      else return TYPE_INTEGER;
    }
  if ((Op1 == TYPE_FLOAT) || (Op2 == TYPE_FLOAT))
    {
      if (OperType == OperRest) Scan->ShowError("   %    !", "", 1);
      else return TYPE_FLOAT;
    }
  return TYPE_INTEGER;
}
////----------------------------------------------------------------------------------------
Tree::Tree(Tree *L, Tree *R, Tree* U, Node* Data)
{
  Left = L;
  Right = R;
  Up = U;
  n = Data;
}
////----------------------------------------------------------------------------------------
void Tree::SetLeft(Node* Data)
{
  if (!StartNode->Cur) StartNode->Cur = new Tree(NULL,NULL,NULL,Data);
  StartNode->Cur->Left = new Tree(NULL,NULL,StartNode->Cur,Data);
}
////----------------------------------------------------------------------------------------
void Tree::SetRight(Node* Data)
{
  if (!StartNode->Cur) StartNode->Cur = new Tree(NULL,NULL,NULL,Data);
  StartNode->Cur->Right = new Tree(NULL,NULL,StartNode->Cur,Data);
}
////----------------------------------------------------------------------------------------
Tree* Tree::FindUp  (Tree* From, LexWord id)//     
{
  Tree* TMP = From;
  while (TMP)
    {
      if (TMP->n->id == id) return TMP;
      TMP = TMP -> Up;
    }
  return NULL;
}
////----------------------------------------------------------------------------------------
Tree* Tree::FindUp (LexWord id) //,   
{
  if (!StartNode->Cur) return NULL;
  Tree* TMP = StartNode->Cur;
  while (TMP)
    {
      if (strcmp(TMP->n->id,id) == 0) return TMP;
      TMP = TMP -> Up;
    }
  return NULL;
}
////----------------------------------------------------------------------------------------
Tree* Tree::FindUpOneLevel (Tree* From, LexWord id) //    
{
  Tree* TMP = From;
  while (TMP)
    {
      if (TMP->n->id == id) return TMP;
      if (TMP->Up)//  
        {
          if (TMP == TMP->Up->Left) TMP = TMP->Up; // TMP -    
          else TMP = NULL;
        }
      else TMP = NULL;
    }
  return TMP;
}
////----------------------------------------------------------------------------------------
int Tree::ArrControl(Tree* var, int n)
{
  if (var == NULL) return -1;
  else if (var->n->array)
         {
           if (var->n->Param == n) return 1;
           else Scan->ShowError("   ", AnsiString(var->n->id), 1);
         }
       else if (n > 0) Scan->ShowError(" " + AnsiString(var->n->id) + "  !","" , 1);
}
//------------------------------------------------------------------------------
DATA_TYPE Tree::OperControl(DATA_TYPE Op1, int OperType)
{
  if (Op1 == TYPE_INTEGER) return TYPE_INTEGER;
  if (Op1 == TYPE_EMPTY) return TYPE_EMPTY;
  if (Op1 == TYPE_UNKNOWN) return TYPE_UNKNOWN;
  if (Op1 == TYPE_ENUM) return TYPE_INTEGER;
  if (Op1 == TYPE_FLOAT)
    {
      if (OperType == OperNot) return TYPE_INTEGER;  //   NOT   INTEGER
      else return TYPE_FLOAT;
    }
}
//------------------------------------------------------------------------------
int Tree::SemGetConst(Tree* Addr)
{
  if (!Addr) return -1;  //
  else if (Addr->n->constant == true) return 1; //
  else return 0; //
}
//------------------------------------------------------------------------------
void Tree::SemSetConst(Tree* Addr, bool cn)
{
  if (!Addr) return;  //
  Addr->n->constant = cn;
}
//------------------------------------------------------------------------------
int Tree::SemGetArray(Tree* Addr)
{
  if (!Addr) return -1;  //
  else if (Addr->n->array == true) return 1; //
  else return 0; //
}
//------------------------------------------------------------------------------
void Tree::SemSetArray(Tree* Addr, bool ar)
{
  if (!Addr) return;  //
  Addr->n->array = ar;
}
//------------------------------------------------------------------------------
Tree::Tree()  // ""  
{
  n = NULL;
  Left = NULL;
  Right = NULL;
}
