//---------------------------------------------------------------------------

#ifndef __SEMAN
#define __SEMAN
//---------------------------------------------------------------------------
#include "defs.hpp"
#include "Scanner.h"
#define EMPTY -1
#define MAX_N 10

#define OperNone 0  // 
#define OperPlus 20
#define OperMinus 21
#define OperMult 22
#define OperDiv 23
#define OperRest 24   //%
#define OperLt 25  //<
#define OperGt 26   //>
#define OperLe 27   //<=
#define OperGe 28   //>=
#define OperEe 29   //==
#define OperNe 30   //!=

#define OperDec 32  //--
#define OperInc 33  //++
#define OperNot 34   //!

struct Node        //               //,  !!!
{                                     //    !    ,   .
  LexWord id;      //
  DATA_TYPE DataType;  //
  bool constant;       // 
  bool array;          // 
  char* Data;          //    NULL
  int Param;           //-  ,   enum'e    
  int HG[MAX_N];       //  
};
//   ,   enuma   !


class Tree
{
  public:
  TScanner* Scan;
  Tree *Cur; //    
  Node *n;   //.   
  Tree *Up, *Left, *Right; //,    
  //    
  Tree(Tree *L, Tree *R, Tree* U, Node* Data);
  Tree();
//  ~Tree();
  void SetLeft (Node* Data);
  void SetRight (Node* Data);
  Tree* FindUp  (Tree* From, LexWord id);
  Tree* FindUpOneLevel  (Tree* From, LexWord id);
  Tree* FindUp (LexWord id);
  void Print(void);

  // 

  void SetCur (Tree* a);  //   
  Tree* GetCur(void);  // .  
  Tree* SemInclude (LexWord a, DATA_TYPE t);  //  a     t
  void SemSetType (Tree* Addr, DATA_TYPE t);  //  t     Addr
  void SemSetParam (Tree* Addr, int n);  //  .    Addr,   enum'a    
  void SemControlParam (Tree* Addr, int n);  //         Addr   
  void SemSetConst (Tree* Addr, bool cn);  ///    
  int SemGetConst (Tree* Addr);  //,     
  void SemSetArray (Tree* Addr, bool ar);  ///    
  int SemGetArray (Tree* Addr);  //,     
  int ArrControl (Tree* var, int n); //,   a      
  Tree* SemGetType (LexWord a);  //      a      
  Tree* SemGetFunc (LexWord a);  //      a      
  int DupControl(Tree* Addr, LexWord a); //  a     .
  DATA_TYPE OperControl(DATA_TYPE Op1, DATA_TYPE Op2, int OperType);  //     - OperType    Op1  Op2
  DATA_TYPE OperControl(DATA_TYPE Op1, int OperType);  //     - OperType    Op1

};


#endif
